=== debian/changelog ===
juju-mongodb2.6 (2.6.10-0ubuntu1) xenial; urgency=medium

  [ Curtis C. Hovey ]
  * New upstream release (LP: #1557830).
  * Updated d/ based on 1:2.6.10-0ubuntu1 d/
  * d/control: 
    - Renamed source and binary package to juju-mongodb2.6.
    - Install to /usr/lib/juju/mongo2.6/bin/
    - Add libyaml-cpp-dev to BD's.
  * d/rules: Enable --with-system-yaml option. 
  * d/p 
    - Synced upstream patches with the mongodb 1:2.6.10-0ubuntu1
    - dropped be-port because juju 1.25 and juju-mongodb will not
      support s390x and powerpc; juju2 will support these archs.

  [ Robie Basak ]
  * Drop ignore of scons clean failure in line with mongodb 2.6.10-0ubuntu1.
  * Drop --system-v8 against mongodb 1:2.6.10-0ubuntu1 since we build without
    any JS engine.
  * d/control: build on "any" architecture. Some are known to fail but not for
    any fundamental reason that makes this package unsuitable for them.

 -- Robie Basak <robie.basak@ubuntu.com>  Mon, 04 Apr 2016 16:23:23 +0000

juju-mongodb (2.4.10-0ubuntu6) xenial; urgency=high

  * Drop architecture restrictions.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 06 Jan 2016 09:27:48 +0000

juju-mongodb (2.4.10-0ubuntu5) xenial; urgency=medium

  * Add be-port.patch from IBM's port. 

 -- Michael Hudson-Doyle <michael.hudson@canonical.com>  Tue, 08 Dec 2015 15:11:35 +1300

juju-mongodb (2.4.10-0ubuntu4) wily; urgency=medium

  * Fix FTBFS: (LP: #1483400)
    - Add 00git_boost_1.56.patch: Fix "std::swap" failure with current boost.
      (Backported from upstream git)
    - Add 00git_pymongo3.patch: Fix buildscripts/smoke.py for PyMongo 3.
      (Backported from upstream git)
    - Add no-unused-variable.patch: Don't fail to build on "unused-variable"
      warning.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Tue, 11 Aug 2015 10:57:23 +0200

juju-mongodb (2.4.10-0ubuntu3) wily; urgency=medium

  * No-change rebuild against libpcrecpp0v5

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 08 Aug 2015 23:35:48 +0000

juju-mongodb (2.4.10-0ubuntu2) vivid; urgency=medium

  * d/p/no-unused-function.patch: Patch to avoid FTBFS with gcc-4.9 by using
    -Wno-unused-function. Patch cherry-picked from mongodb package in Vivid. 

 -- Oleg Strikov <oleg.strikov@canonical.com>  Mon, 20 Apr 2015 13:55:27 +0000

juju-mongodb (2.4.10-0ubuntu1) utopic; urgency=medium

  * New upstream release.

 -- James Page <james.page@ubuntu.com>  Wed, 30 Apr 2014 08:59:21 +0100

juju-mongodb (2.4.9-0ubuntu3) trusty; urgency=medium

  * d/p/0099-Pagesize-hacks.patch: Apply some hacks for non-4k pages.

 -- Adam Conrad <adconrad@ubuntu.com>  Thu, 27 Mar 2014 00:47:53 -0600

juju-mongodb (2.4.9-0ubuntu2) trusty; urgency=medium

  * d/tests/binaries: Drop check for mongo binary.

 -- James Page <james.page@ubuntu.com>  Wed, 22 Jan 2014 16:39:13 +0000

juju-mongodb (2.4.9-0ubuntu1) trusty; urgency=medium

  * New upstream point release.
  * d/p/0003-SERVER-12064-Use-gcc-atomic-builtins-if-available.patch:
    Dropped - not really needed for this version on mongodb.
  * d/install: Don't ship mongo binary, its broken without a JS engine
    (LP: #1270098).
  * d/p/0005-disable-jstests.patch: Dropped in preference to updates to
    d/p/0001-Add-option-to-disable-javascript.patch - rebased on revised
    upstream pull request.
  * d/rules: Don't strip binaries during build so we get a ddeb.

 -- James Page <james.page@ubuntu.com>  Wed, 22 Jan 2014 14:52:36 +0000

juju-mongodb (2.4.8-0ubuntu6) trusty; urgency=medium

  * Switch back to running standard smoke test suite, minus jstests:
    - d/rules: Use smoke target for test execution.
    - d/patches/0005-disable-jstests.patch: Disable jstests suite.

 -- James Page <james.page@ubuntu.com>  Tue, 07 Jan 2014 21:51:41 +0000

juju-mongodb (2.4.8-0ubuntu5) trusty; urgency=medium

  * Enable better support for alternative architectures:
    - 0001-SERVER-12064-Atomic-operations-for-gcc-non-Intel-arc.patch
      0002-SERVER-12065-Support-ARM-and-AArch64-builds.patch
      0003-SERVER-12064-Use-gcc-atomic-builtins-if-available.patch:
      Cherry picked changes from Robie Basak to enable atomic operations
      on non-Intel architectures.
    - 0004-Support-ppc64el-builds.patch: Add support for detection of
      powerpc64 as a 64-bit platform.
    - d/control: Enable arm64 and ppc64el architectures.

 -- James Page <james.page@ubuntu.com>  Tue, 07 Jan 2014 16:47:27 +0000

juju-mongodb (2.4.8-0ubuntu4) trusty; urgency=medium

  * Disable javascript scripting support:
    - d/rules: Pass --disable-scripting, drop config options for v8 and sm,
      only run C++ based tests during smoke testing.
    - d/p/0001-Add-option-to-disable-javascript.patch: Cherry picked changes 
      from Michael Hudson to add support for disabling javascript support.

 -- James Page <james.page@ubuntu.com>  Tue, 07 Jan 2014 14:48:30 +0000

juju-mongodb (2.4.8-0ubuntu3) trusty; urgency=medium

  * d/rules: Ignore test failures when testing with spidermonkey
    scripting engine for the time being.
  * d/control: Drop dependency on adduser as its not required.

 -- James Page <james.page@ubuntu.com>  Thu, 19 Dec 2013 16:37:23 +0000

juju-mongodb (2.4.8-0ubuntu2) trusty; urgency=medium

  * d/rules: Use spidermonkey as scripting engine for architectures that
    don't currently have v8 support.
  * d/tests/binaries: Fix exit code handling to resolve autopkg test failure.
  * d/rules: Ignore errors from scons clean.

 -- James Page <james.page@ubuntu.com>  Tue, 17 Dec 2013 08:33:20 +0000

juju-mongodb (2.4.8-0ubuntu1) trusty; urgency=low

  * Create new binary only MongoDB package for use by Juju, supporting
    plans for inclusion of juju-core in Ubuntu main:
    - d/control: Add new juju-mongodb package, drop all others.
    - d/control: Use embedded v8 to avoid general inclusion in main.
    - d/control,d/p/series: Drop use of system libstemmer in preference
      to embedded version.

